diff --git a/gcc/cp/typeck.c b/gcc/cp/typeck.c
index 559f19b5..2fedb1e 100644
--- a/gcc/cp/typeck.c
+++ b/gcc/cp/typeck.c
@@ -1558,7 +1558,7 @@ cxx_sizeof_or_alignof_type (tree type, enum tree_code op, bool complain)
     }
 
   if (cxx_dialect >= cxx1y && array_of_runtime_bound_p (type)
-      && (flag_iso || warn_vla > 0))
+      && (flag_iso || GCC_OPTION (warn_vla) > 0))
     {
       if (complain & tf_warning_or_error)
 	pedwarn (input_location, OPT_Wvla,
@@ -1791,7 +1791,7 @@ invalid_nonstatic_memfn_p (tree expr, tsubst_flags_t complain)
   if (expr == NULL_TREE)
     return false;
   /* Don't enforce this in MS mode.  */
-  if (flag_ms_extensions)
+  if (GCC_OPTION (flag_ms_extensions))
     return false;
   if (is_overloaded_fn (expr) && !really_overloaded_fn (expr))
     expr = get_first_fn (expr);
@@ -2365,7 +2365,7 @@ build_class_member_access_expr (tree object, tree member,
 	 we know for a fact that didn't come from offsetof.  This does occur
 	 in various testsuite cases where a null object is passed where a
 	 vtable access is required.  */
-      if (null_object_p && warn_invalid_offsetof
+      if (null_object_p && GCC_OPTION (warn_invalid_offsetof)
 	  && CLASSTYPE_NON_STD_LAYOUT (object_type)
 	  && !DECL_FIELD_IS_BASE (member)
 	  && cp_unevaluated_operand == 0
@@ -2929,7 +2929,7 @@ cp_build_indirect_ref (tree ptr, ref_operator errorstring,
 	  /* If a warning is issued, mark it to avoid duplicates from
 	     the backend.  This only needs to be done at
 	     warn_strict_aliasing > 2.  */
-	  if (warn_strict_aliasing > 2)
+	  if (GCC_OPTION (warn_strict_aliasing) > 2)
 	    if (strict_aliasing_warning (TREE_TYPE (TREE_OPERAND (ptr, 0)),
 					 type, TREE_OPERAND (ptr, 0)))
 	      TREE_NO_WARNING (ptr) = 1;
@@ -3022,7 +3022,7 @@ cp_build_array_ref (location_t loc, tree array, tree idx,
 
   /* If an array's index is an array notation, then its rank cannot be
      greater than one.  */ 
-  if (flag_cilkplus && contains_array_notation_expr (idx))
+  if (GCC_OPTION (flag_cilkplus) && contains_array_notation_expr (idx))
     {
       size_t rank = 0;
 
@@ -3123,7 +3123,7 @@ cp_build_array_ref (location_t loc, tree array, tree idx,
       /* Note in C++ it is valid to subscript a `register' array, since
 	 it is valid to take the address of something with that
 	 storage specification.  */
-      if (extra_warnings)
+      if (GCC_OPTION (extra_warnings))
 	{
 	  tree foo = array;
 	  while (TREE_CODE (foo) == COMPONENT_REF)
@@ -3484,7 +3484,7 @@ cp_build_function_call_vec (tree function, vec<tree, va_gc> **params,
     {
       if (complain & tf_error)
 	{
-	  if (!flag_diagnostics_show_caret)
+	  if (!GCC_OPTION (flag_diagnostics_show_caret))
 	    error_at (input_location,
 		      "%qE cannot be used as a function", original);
 	  else if (DECL_P (original))
@@ -3768,7 +3768,7 @@ build_x_binary_op (location_t loc, enum tree_code code, tree arg1,
   /* Check for cases such as x+y<<z which users are likely to
      misinterpret.  But don't warn about obj << x + y, since that is a
      common idiom for I/O.  */
-  if (warn_parentheses
+  if (GCC_OPTION (warn_parentheses)
       && (complain & tf_warning)
       && !processing_template_decl
       && !error_operand_p (arg1)
@@ -4625,14 +4625,14 @@ cp_build_binary_op (location_t location,
       else if (code0 == POINTER_TYPE && null_ptr_cst_p (op1))
 	{
 	  result_type = type0;
-	  if (extra_warnings && (complain & tf_warning))
+	  if (GCC_OPTION (extra_warnings) && (complain & tf_warning))
 	    warning (OPT_Wextra,
 		     "ordered comparison of pointer with integer zero");
 	}
       else if (code1 == POINTER_TYPE && null_ptr_cst_p (op0))
 	{
 	  result_type = type1;
-	  if (extra_warnings && (complain & tf_warning))
+	  if (GCC_OPTION (extra_warnings) && (complain & tf_warning))
 	    warning (OPT_Wextra,
 		     "ordered comparison of pointer with integer zero");
 	}
@@ -4749,7 +4749,7 @@ cp_build_binary_op (location_t location,
 	      || code == MULT_EXPR
 	      || (code == TRUNC_DIV_EXPR && first_complex))
 	  && TREE_CODE (TREE_TYPE (result_type)) == REAL_TYPE
-	  && flag_signed_zeros)
+	  && GCC_OPTION (flag_signed_zeros))
 	{
 	  /* An operation on mixed real/complex operands must be
 	     handled specially, but the language-independent code can
@@ -4863,7 +4863,7 @@ cp_build_binary_op (location_t location,
 	}
 
       if ((short_compare || code == MIN_EXPR || code == MAX_EXPR)
-	  && warn_sign_compare
+	  && GCC_OPTION (warn_sign_compare)
 	  /* Do not warn until the template is instantiated; we cannot
 	     bound the ranges of the arguments until that point.  */
 	  && !processing_template_decl
@@ -4904,7 +4904,7 @@ cp_build_binary_op (location_t location,
   if (build_type == NULL_TREE)
     build_type = result_type;
 
-  if ((flag_sanitize & (SANITIZE_SHIFT | SANITIZE_DIVIDE))
+  if ((GCC_OPTION (flag_sanitize) & (SANITIZE_SHIFT | SANITIZE_DIVIDE))
       && !processing_template_decl
       && current_function_decl != 0
       && !lookup_attribute ("no_sanitize_undefined",
@@ -4918,7 +4918,7 @@ cp_build_binary_op (location_t location,
 								  tf_none));
       op1 = maybe_constant_value (fold_non_dependent_expr_sfinae (op1,
 								  tf_none));
-      if (doing_div_or_mod && (flag_sanitize & SANITIZE_DIVIDE))
+      if (doing_div_or_mod && (GCC_OPTION (flag_sanitize) & SANITIZE_DIVIDE))
 	{
 	  /* For diagnostics we want to use the promoted types without
 	     shorten_binary_op.  So convert the arguments to the
@@ -4932,7 +4932,7 @@ cp_build_binary_op (location_t location,
 	    }
 	  instrument_expr = ubsan_instrument_division (location, cop0, cop1);
 	}
-      else if (doing_shift && (flag_sanitize & SANITIZE_SHIFT))
+      else if (doing_shift && (GCC_OPTION (flag_sanitize) & SANITIZE_SHIFT))
 	instrument_expr = ubsan_instrument_shift (location, code, op0, op1);
     }
 
@@ -5135,7 +5135,7 @@ build_x_unary_op (location_t loc, enum tree_code code, tree xarg,
 
       /* A pointer to member-function can be formed only by saying
 	 &X::mf.  */
-      if (!flag_ms_extensions && TREE_CODE (TREE_TYPE (xarg)) == METHOD_TYPE
+      if (!GCC_OPTION (flag_ms_extensions) && TREE_CODE (TREE_TYPE (xarg)) == METHOD_TYPE
 	  && (TREE_CODE (xarg) != OFFSET_REF || !PTRMEM_OK_P (xarg)))
 	{
 	  if (TREE_CODE (xarg) != OFFSET_REF
@@ -5166,7 +5166,7 @@ build_x_unary_op (location_t loc, enum tree_code code, tree xarg,
 	{
 	  ptrmem = PTRMEM_OK_P (xarg);
 
-	  if (!ptrmem && !flag_ms_extensions
+	  if (!ptrmem && !GCC_OPTION (flag_ms_extensions)
 	      && TREE_CODE (TREE_TYPE (TREE_OPERAND (xarg, 1))) == METHOD_TYPE)
 	    {
 	      /* A single non-static member, make sure we don't allow a
@@ -5309,7 +5309,7 @@ cp_build_addr_expr_1 (tree arg, bool strict_lvalue, tsubst_flags_t complain)
       tree fn = get_first_fn (TREE_OPERAND (arg, 1));
       mark_used (fn);
 
-      if (! flag_ms_extensions)
+      if (! GCC_OPTION (flag_ms_extensions))
 	{
 	  tree name = DECL_NAME (fn);
 	  if (!(complain & tf_error))
@@ -5371,15 +5371,15 @@ cp_build_addr_expr_1 (tree arg, bool strict_lvalue, tsubst_flags_t complain)
       arg = build1 (CONVERT_EXPR, type, arg);
       return arg;
     }
-  else if (pedantic && DECL_MAIN_P (arg))
+  else if (GCC_OPTION (pedantic) && DECL_MAIN_P (arg))
     {
       /* ARM $3.4 */
       /* Apparently a lot of autoconf scripts for C++ packages do this,
 	 so only complain if -Wpedantic.  */
-      if (complain & (flag_pedantic_errors ? tf_error : tf_warning))
+      if (complain & (GCC_OPTION (flag_pedantic_errors) ? tf_error : tf_warning))
 	pedwarn (input_location, OPT_Wpedantic,
 		 "ISO C++ forbids taking address of function %<::main%>");
-      else if (flag_pedantic_errors)
+      else if (GCC_OPTION (flag_pedantic_errors))
 	return error_mark_node;
     }
 
@@ -5478,7 +5478,7 @@ cp_build_addr_expr_1 (tree arg, bool strict_lvalue, tsubst_flags_t complain)
   if (argtype != error_mark_node)
     {
       if (cxx_dialect >= cxx1y && array_of_runtime_bound_p (argtype)
-	  && (flag_iso || warn_vla > 0))
+	  && (flag_iso || GCC_OPTION (warn_vla) > 0))
 	{
 	  if (complain & tf_warning_or_error)
 	    pedwarn (input_location, OPT_Wvla,
@@ -6001,7 +6001,7 @@ cxx_mark_addressable (tree exp)
 		  ("address of explicit register variable %qD requested", x);
 		return false;
 	      }
-	    else if (extra_warnings)
+	    else if (GCC_OPTION (extra_warnings))
 	      warning
 		(OPT_Wextra, "address requested for %qD, which is declared %<register%>", x);
 	  }
@@ -6206,7 +6206,7 @@ cp_build_compound_expr (tree lhs, tree rhs, tsubst_flags_t complain)
   if (lhs == error_mark_node || rhs == error_mark_node)
     return error_mark_node;
 
-  if (flag_cilkplus
+  if (GCC_OPTION (flag_cilkplus)
       && (TREE_CODE (lhs) == CILK_SPAWN_STMT
 	  || TREE_CODE (rhs) == CILK_SPAWN_STMT))
     {
@@ -6255,7 +6255,7 @@ check_for_casting_away_constness (tree src_type, tree dest_type,
 {
   /* C-style casts are allowed to cast away constness.  With
      WARN_CAST_QUAL, we still want to issue a warning.  */
-  if (cast == CAST_EXPR && !warn_cast_qual)
+  if (cast == CAST_EXPR && !GCC_OPTION (warn_cast_qual))
     return false;
   
   if (!casts_away_constness (src_type, dest_type, complain))
@@ -6293,7 +6293,7 @@ check_for_casting_away_constness (tree src_type, tree dest_type,
 void
 maybe_warn_about_useless_cast (tree type, tree expr, tsubst_flags_t complain)
 {
-  if (warn_useless_cast
+  if (GCC_OPTION (warn_useless_cast)
       && complain & tf_warning)
     {
       /* In C++14 mode, this interacts badly with force_paren_expr.  And it
@@ -6679,8 +6679,8 @@ convert_member_func_to_ptr (tree type, tree expr, tsubst_flags_t complain)
   if (!(complain & tf_warning_or_error))
     return error_mark_node;
 
-  if (pedantic || warn_pmf2ptr)
-    pedwarn (input_location, pedantic ? OPT_Wpedantic : OPT_Wpmf_conversions,
+  if (GCC_OPTION (pedantic) || GCC_OPTION (warn_pmf2ptr))
+    pedwarn (input_location, GCC_OPTION (pedantic) ? OPT_Wpedantic : OPT_Wpmf_conversions,
 	     "converting from %qT to %qT", intype, type);
 
   if (TREE_CODE (intype) == METHOD_TYPE)
@@ -6751,7 +6751,7 @@ build_reinterpret_cast_1 (tree type, tree expr, bool c_cast_p,
 
       expr = cp_build_addr_expr (expr, complain);
 
-      if (warn_strict_aliasing > 2)
+      if (GCC_OPTION (warn_strict_aliasing) > 2)
 	strict_aliasing_warning (TREE_TYPE (expr), type, expr);
 
       if (expr != error_mark_node)
@@ -6836,7 +6836,7 @@ build_reinterpret_cast_1 (tree type, tree expr, bool c_cast_p,
 					       complain))
 	return error_mark_node;
       /* Warn about possible alignment problems.  */
-      if (STRICT_ALIGNMENT && warn_cast_align
+      if (STRICT_ALIGNMENT && GCC_OPTION (warn_cast_align)
           && (complain & tf_warning)
 	  && !VOID_TYPE_P (type)
 	  && TREE_CODE (TREE_TYPE (intype)) != FUNCTION_TYPE
@@ -6849,7 +6849,7 @@ build_reinterpret_cast_1 (tree type, tree expr, bool c_cast_p,
       /* We need to strip nops here, because the front end likes to
 	 create (int *)&a for array-to-pointer decay, instead of &a[0].  */
       STRIP_NOPS (sexpr);
-      if (warn_strict_aliasing <= 2)
+      if (GCC_OPTION (warn_strict_aliasing) <= 2)
 	strict_aliasing_warning (intype, type, sexpr);
 
       return fold_if_not_in_template (build_nop (type, expr));
@@ -7559,7 +7559,7 @@ cp_build_modify_expr (tree lhs, enum tree_code modifycode, tree rhs,
   if (newrhs == error_mark_node)
     return error_mark_node;
 
-  if (c_dialect_objc () && flag_objc_gc)
+  if (c_dialect_objc () && GCC_OPTION (flag_objc_gc))
     {
       result = objc_generate_write_barrier (lhs, modifycode, newrhs);
 
@@ -8053,7 +8053,7 @@ convert_for_assignment (tree type, tree rhs,
       /* When -Wno-pmf-conversions is use, we just silently allow
 	 conversions from pointers-to-members to plain pointers.  If
 	 the conversion doesn't work, cp_convert will complain.  */
-      if (!warn_pmf2ptr
+      if (!GCC_OPTION (warn_pmf2ptr)
 	  && TYPE_PTR_P (type)
 	  && TYPE_PTRMEMFUNC_P (rhstype))
 	rhs = cp_convert (strip_top_quals (type), rhs, complain);
@@ -8103,7 +8103,7 @@ convert_for_assignment (tree type, tree rhs,
 	  return error_mark_node;
 	}
     }
-  if (warn_suggest_attribute_format)
+  if (GCC_OPTION (warn_suggest_attribute_format))
     {
       const enum tree_code codel = TREE_CODE (type);
       if ((codel == POINTER_TYPE || codel == REFERENCE_TYPE)
@@ -8150,7 +8150,7 @@ convert_for_assignment (tree type, tree rhs,
 
   /* If -Wparentheses, warn about a = b = c when a has type bool and b
      does not.  */
-  if (warn_parentheses
+  if (GCC_OPTION (warn_parentheses)
       && TREE_CODE (type) == BOOLEAN_TYPE
       && TREE_CODE (rhs) == MODIFY_EXPR
       && !TREE_NO_WARNING (rhs)
@@ -8342,7 +8342,7 @@ check_return_expr (tree retval, bool *no_warning)
 
   *no_warning = false;
 
-  if (flag_cilkplus && retval && contains_cilk_spawn_stmt (retval))
+  if (GCC_OPTION (flag_cilkplus) && retval && contains_cilk_spawn_stmt (retval))
     {
       error_at (EXPR_LOCATION (retval), "use of %<_Cilk_spawn%> in a return "
 		"statement is not allowed");
@@ -8484,13 +8484,13 @@ check_return_expr (tree retval, bool *no_warning)
   if ((DECL_OVERLOADED_OPERATOR_P (current_function_decl) == NEW_EXPR
        || DECL_OVERLOADED_OPERATOR_P (current_function_decl) == VEC_NEW_EXPR)
       && !TYPE_NOTHROW_P (TREE_TYPE (current_function_decl))
-      && ! flag_check_new
+      && ! GCC_OPTION (flag_check_new)
       && retval && null_ptr_cst_p (retval))
     warning (0, "%<operator new%> must not return NULL unless it is "
 	     "declared %<throw()%> (or -fcheck-new is in effect)");
 
   /* Effective C++ rule 15.  See also start_function.  */
-  if (warn_ecpp
+  if (GCC_OPTION (warn_ecpp)
       && DECL_NAME (current_function_decl) == ansi_assopname(NOP_EXPR))
     {
       bool warn = true;
@@ -8551,7 +8551,7 @@ check_return_expr (tree retval, bool *no_warning)
      /* And the returned value must be non-volatile.  */
      && ! TYPE_VOLATILE (TREE_TYPE (retval)));
      
-  if (fn_returns_value_p && flag_elide_constructors)
+  if (fn_returns_value_p && GCC_OPTION (flag_elide_constructors))
     {
       if (named_return_value_okay_p
           && (current_function_return_value == NULL_TREE
diff --git a/gcc/cp/typeck2.c b/gcc/cp/typeck2.c
index bd21ad8..eed5a32 100644
--- a/gcc/cp/typeck2.c
+++ b/gcc/cp/typeck2.c
@@ -496,7 +496,7 @@ cxx_incomplete_type_diagnostic (const_tree value, const_tree type,
 	if (is_overloaded_fn (member))
 	  member = get_first_fn (member);
 	if (DECL_FUNCTION_MEMBER_P (member)
-	    && ! flag_ms_extensions)
+	    && ! GCC_OPTION (flag_ms_extensions))
 	  emit_diagnostic (diag_kind, input_location, 0,
 			   "invalid use of member function "
 			   "(did you forget the %<()%> ?)");
@@ -847,7 +847,7 @@ check_narrowing (tree type, tree init)
   bool ok = true;
   REAL_VALUE_TYPE d;
 
-  if (!warn_narrowing || !ARITHMETIC_TYPE_P (type))
+  if (!GCC_OPTION (warn_narrowing) || !ARITHMETIC_TYPE_P (type))
     return;
 
   if (BRACE_ENCLOSED_INITIALIZER_P (init)
diff --git a/gcc/cp/vtable-class-hierarchy.c b/gcc/cp/vtable-class-hierarchy.c
index 6da17c7..904d00f 100644
--- a/gcc/cp/vtable-class-hierarchy.c
+++ b/gcc/cp/vtable-class-hierarchy.c
@@ -166,7 +166,7 @@ vtv_build_vtable_verify_fndecl (void)
       && TREE_CODE (verify_vtbl_ptr_fndecl) != ERROR_MARK)
     return;
 
-  if (flag_vtv_debug)
+  if (GCC_OPTION (flag_vtv_debug))
     {
       func_type = build_function_type_list (const_ptr_type_node,
                                             build_pointer_type (ptr_type_node),
@@ -242,7 +242,7 @@ init_functions (void)
                                               build_pointer_type (ptr_type_node),
                                               NULL_TREE);
 
-  if (flag_vtv_debug)
+  if (GCC_OPTION (flag_vtv_debug))
     vlt_register_set_fndecl = build_lang_decl
                                        (FUNCTION_DECL,
                                         get_identifier ("__VLTRegisterSetDebug"),
@@ -265,7 +265,7 @@ init_functions (void)
 
   /* Build function decl for __VLTRegisterPair*.  */
 
-  if (flag_vtv_debug)
+  if (GCC_OPTION (flag_vtv_debug))
     {
       register_pairs_type = build_function_type_list (void_type_node,
                                                       build_pointer_type
@@ -686,7 +686,7 @@ vtv_string_hash (const char *in)
 static char *
 get_log_file_name (const char *fname)
 {
-  const char *tmp_dir = concat (dump_dir_name, NULL);
+  const char *tmp_dir = concat (GCC_OPTION (dump_dir_name), NULL);
   char *full_name;
   int dir_len;
   int fname_len;
@@ -828,7 +828,7 @@ insert_call_to_register_pair (vec<tree> *vtbl_ptr_array, tree arg1,
   else
     vtable_address = (*vtbl_ptr_array)[0];
 
-  if (flag_vtv_debug)
+  if (GCC_OPTION (flag_vtv_debug))
     call_expr = build_call_expr (vlt_register_pairs_fndecl, 6, arg1, arg2,
                                  size_hint_arg, vtable_address, str1, str2);
   else
@@ -881,7 +881,7 @@ output_set_info (tree record_type, vec<tree> vtbl_ptr_array)
         }
 
       snprintf (buffer, sizeof (buffer), "%s %s %s + %d\n",
-                main_input_filename, class_name, vptr_name, vptr_offset);
+                GCC_OPTION (main_input_filename), class_name, vptr_name, vptr_offset);
       bytes_written = write (vtv_debug_log_fd, buffer, strlen(buffer));
     }
 
@@ -919,7 +919,7 @@ register_all_pairs (tree body)
       gcc_assert (current->class_info != NULL);
 
 
-      if (flag_vtv_debug)
+      if (GCC_OPTION (flag_vtv_debug))
         str1 = build_string_from_id (DECL_NAME (base_ptr_var_decl));
 
       new_type = build_pointer_type (TREE_TYPE (base_ptr_var_decl));
@@ -1012,7 +1012,7 @@ register_all_pairs (tree body)
         str2 = build_string_literal (strlen ("unknown") + 1,
                                      "unknown");
 
-      if (flag_vtv_debug)
+      if (GCC_OPTION (flag_vtv_debug))
         output_set_info (current->class_info->class_type,
                          *vtbl_ptr_array);
 
@@ -1037,7 +1037,7 @@ register_all_pairs (tree body)
             }
         }
 
-      if (flag_vtv_counts && current_set_size > 0)
+      if (GCC_OPTION (flag_vtv_counts) && current_set_size > 0)
         write_out_current_set_data (base_class, current_set_size);
 
     }
@@ -1119,7 +1119,7 @@ write_out_vtv_count_data (void)
     }
 
   snprintf (buffer, sizeof (buffer), "%s %d %d %d %d %d\n",
-            main_input_filename, total_num_virtual_calls,
+            GCC_OPTION (main_input_filename), total_num_virtual_calls,
             total_num_verified_vcalls, num_calls_to_regset,
             num_calls_to_regpair, unused_vtbl_map_vars);
 
@@ -1147,7 +1147,7 @@ vtv_register_class_hierarchy_information (tree init_routine_body)
   /* Add class hierarchy pairs to the vtable map data structure.  */
   registered_something = register_all_pairs (init_routine_body);
 
-  if (flag_vtv_counts)
+  if (GCC_OPTION (flag_vtv_counts))
     write_out_vtv_count_data ();
 
   return registered_something;
@@ -1182,7 +1182,7 @@ vtv_generate_init_routine (void)
       TREE_STATIC (vtv_fndecl) = 1;
       TREE_USED (vtv_fndecl) = 1;
       DECL_PRESERVE_P (vtv_fndecl) = 1;
-      if (flag_vtable_verify == VTV_PREINIT_PRIORITY)
+      if (GCC_OPTION (flag_vtable_verify) == VTV_PREINIT_PRIORITY)
         DECL_STATIC_CONSTRUCTOR (vtv_fndecl) = 0;
 
       gimplify_function_tree (vtv_fndecl);
@@ -1190,7 +1190,7 @@ vtv_generate_init_routine (void)
 
       cgraph_process_new_functions ();
 
-      if (flag_vtable_verify == VTV_PREINIT_PRIORITY)
+      if (GCC_OPTION (flag_vtable_verify) == VTV_PREINIT_PRIORITY)
         assemble_vtv_preinit_initializer (vtv_fndecl);
 
     }
@@ -1273,7 +1273,7 @@ vtable_find_or_create_map_decl (tree base_type)
 static void
 vtv_insert_single_class_info (tree type)
 {
-  if (flag_vtable_verify)
+  if (GCC_OPTION (flag_vtable_verify))
     {
       tree binfo =  TYPE_BINFO (type);
       tree base_binfo;
@@ -1310,7 +1310,7 @@ vtv_insert_single_class_info (tree type)
 void
 vtv_save_class_info (tree record)
 {
-  if (!flag_vtable_verify || TREE_CODE (record) == UNION_TYPE)
+  if (!GCC_OPTION (flag_vtable_verify) || TREE_CODE (record) == UNION_TYPE)
     return;
 
   if (!vlt_saved_class_info)
diff --git a/gcc/cppbuiltin.c b/gcc/cppbuiltin.c
index 8b2c6b4..0beda0f 100644
--- a/gcc/cppbuiltin.c
+++ b/gcc/cppbuiltin.c
@@ -79,33 +79,33 @@ define__GNUC__ (cpp_reader *pfile)
 static void
 define_builtin_macros_for_compilation_flags (cpp_reader *pfile)
 {
-  if (flag_pic)
+  if (GCC_OPTION (flag_pic))
     {
-      cpp_define_formatted (pfile, "__pic__=%d", flag_pic);
-      cpp_define_formatted (pfile, "__PIC__=%d", flag_pic);
+      cpp_define_formatted (pfile, "__pic__=%d", GCC_OPTION (flag_pic));
+      cpp_define_formatted (pfile, "__PIC__=%d", GCC_OPTION (flag_pic));
     }
-  if (flag_pie)
+  if (GCC_OPTION (flag_pie))
     {
-      cpp_define_formatted (pfile, "__pie__=%d", flag_pie);
-      cpp_define_formatted (pfile, "__PIE__=%d", flag_pie);
+      cpp_define_formatted (pfile, "__pie__=%d", GCC_OPTION (flag_pie));
+      cpp_define_formatted (pfile, "__PIE__=%d", GCC_OPTION (flag_pie));
     }
 
-  if (flag_sanitize & SANITIZE_ADDRESS)
+  if (GCC_OPTION (flag_sanitize) & SANITIZE_ADDRESS)
     cpp_define (pfile, "__SANITIZE_ADDRESS__");
 
-  if (optimize_size)
+  if (GCC_OPTION (optimize_size))
     cpp_define (pfile, "__OPTIMIZE_SIZE__");
-  if (optimize)
+  if (GCC_OPTION (optimize))
     cpp_define (pfile, "__OPTIMIZE__");
 
   if (fast_math_flags_set_p (&global_options))
     cpp_define (pfile, "__FAST_MATH__");
-  if (flag_signaling_nans)
+  if (GCC_OPTION (flag_signaling_nans))
     cpp_define (pfile, "__SUPPORT_SNAN__");
 
   cpp_define_formatted (pfile, "__FINITE_MATH_ONLY__=%d",
-			flag_finite_math_only);
-  if (flag_cilkplus)
+			GCC_OPTION (flag_finite_math_only));
+  if (GCC_OPTION (flag_cilkplus))
     cpp_define (pfile, "__cilk=200");
 }
 
diff --git a/gcc/cprop.c b/gcc/cprop.c
index c3acb05..3a76f56 100644
--- a/gcc/cprop.c
+++ b/gcc/cprop.c
@@ -1899,7 +1899,7 @@ one_cprop_pass (void)
 static bool
 gate_rtl_cprop (void)
 {
-  return optimize > 0 && flag_gcse
+  return GCC_OPTION (optimize) > 0 && GCC_OPTION (flag_gcse)
     && !cfun->calls_setjmp
     && dbg_cnt (cprop);
 }
diff --git a/gcc/cse.c b/gcc/cse.c
index 852d13e..a9aab44 100644
--- a/gcc/cse.c
+++ b/gcc/cse.c
@@ -4802,7 +4802,7 @@ cse_insn (rtx insn)
 	 have done the AND in a wider mode, we can use a SUBREG of that
 	 value.  */
 
-      if (flag_expensive_optimizations && ! src_related
+      if (GCC_OPTION (flag_expensive_optimizations) && ! src_related
 	  && GET_CODE (src) == AND && CONST_INT_P (XEXP (src, 1))
 	  && GET_MODE_SIZE (mode) < UNITS_PER_WORD)
 	{
@@ -4845,7 +4845,7 @@ cse_insn (rtx insn)
 	 also have such operations, but this is only likely to be
 	 beneficial on these machines.  */
 
-      if (flag_expensive_optimizations && src_related == 0
+      if (GCC_OPTION (flag_expensive_optimizations) && src_related == 0
 	  && (GET_MODE_SIZE (mode) < UNITS_PER_WORD)
 	  && GET_MODE_CLASS (mode) == MODE_INT
 	  && MEM_P (src) && ! do_not_record
@@ -5777,7 +5777,7 @@ cse_insn (rtx insn)
 	/* Don't record value if we are not supposed to risk allocating
 	   floating-point values in registers that might be wider than
 	   memory.  */
-	if ((flag_float_store
+	if ((GCC_OPTION (flag_float_store)
 	     && MEM_P (dest)
 	     && FLOAT_MODE_P (GET_MODE (dest)))
 	    /* Don't record BLKmode values, because we don't know the
@@ -6595,7 +6595,7 @@ cse_main (rtx f ATTRIBUTE_UNUSED, int nregs)
 	     && i < n_blocks);
 
       /* Find all paths starting with BB, and process them.  */
-      while (cse_find_path (bb, &ebb_data, flag_cse_follow_jumps))
+      while (cse_find_path (bb, &ebb_data, GCC_OPTION (flag_cse_follow_jumps)))
 	{
 	  /* Pre-scan the path.  */
 	  cse_prescan_path (&ebb_data);
@@ -7453,7 +7453,7 @@ cse_condition_code_reg (void)
 static bool
 gate_handle_cse (void)
 {
-  return optimize > 0;
+  return GCC_OPTION (optimize) > 0;
 }
 
 static unsigned int
@@ -7468,7 +7468,7 @@ rest_of_handle_cse (void)
 
   /* If we are not running more CSE passes, then we are no longer
      expecting CSE to be run.  But always rerun it in a cheap mode.  */
-  cse_not_expected = !flag_rerun_cse_after_loop && !flag_gcse;
+  cse_not_expected = !GCC_OPTION (flag_rerun_cse_after_loop) && !GCC_OPTION (flag_gcse);
 
   if (tem == 2)
     {
@@ -7477,7 +7477,7 @@ rest_of_handle_cse (void)
       cleanup_cfg (CLEANUP_CFG_CHANGED);
       timevar_pop (TV_JUMP);
     }
-  else if (tem == 1 || optimize > 1)
+  else if (tem == 1 || GCC_OPTION (optimize) > 1)
     cleanup_cfg (0);
 
   return 0;
@@ -7526,7 +7526,7 @@ make_pass_cse (gcc::context *ctxt)
 static bool
 gate_handle_cse2 (void)
 {
-  return optimize > 0 && flag_rerun_cse_after_loop;
+  return GCC_OPTION (optimize) > 0 && GCC_OPTION (flag_rerun_cse_after_loop);
 }
 
 /* Run second CSE pass after loop optimizations.  */
@@ -7605,7 +7605,7 @@ make_pass_cse2 (gcc::context *ctxt)
 static bool
 gate_handle_cse_after_global_opts (void)
 {
-  return optimize > 0 && flag_rerun_cse_after_global_opts;
+  return GCC_OPTION (optimize) > 0 && flag_rerun_cse_after_global_opts;
 }
 
 /* Run second CSE pass after loop optimizations.  */
@@ -7616,15 +7616,15 @@ rest_of_handle_cse_after_global_opts (void)
   int tem;
 
   /* We only want to do local CSE, so don't follow jumps.  */
-  save_cfj = flag_cse_follow_jumps;
-  flag_cse_follow_jumps = 0;
+  save_cfj = GCC_OPTION (flag_cse_follow_jumps);
+  GCC_OPTION (flag_cse_follow_jumps) = 0;
 
   rebuild_jump_labels (get_insns ());
   tem = cse_main (get_insns (), max_reg_num ());
   purge_all_dead_edges ();
   delete_trivially_dead_insns (get_insns (), max_reg_num ());
 
-  cse_not_expected = !flag_rerun_cse_after_loop;
+  cse_not_expected = !GCC_OPTION (flag_rerun_cse_after_loop);
 
   /* If cse altered any jumps, rerun jump opts to clean things up.  */
   if (tem == 2)
@@ -7637,7 +7637,7 @@ rest_of_handle_cse_after_global_opts (void)
   else if (tem == 1)
     cleanup_cfg (0);
 
-  flag_cse_follow_jumps = save_cfj;
+  GCC_OPTION (flag_cse_follow_jumps) = save_cfj;
   return 0;
 }
 
diff --git a/gcc/cselib.c b/gcc/cselib.c
index 26bcbe0..de2230d 100644
--- a/gcc/cselib.c
+++ b/gcc/cselib.c
@@ -1324,7 +1324,7 @@ new_cselib_val (unsigned int hash, enum machine_mode mode, rtx x)
   if (dump_file && (dump_flags & TDF_CSELIB))
     {
       fprintf (dump_file, "cselib value %u:%u ", e->uid, hash);
-      if (flag_dump_noaddr || flag_dump_unnumbered)
+      if (GCC_OPTION (flag_dump_noaddr) || GCC_OPTION (flag_dump_unnumbered))
 	fputs ("# ", dump_file);
       else
 	fprintf (dump_file, "%p ", (void*)e);
@@ -1381,7 +1381,7 @@ cselib_lookup_mem (rtx x, int create)
 
   if (MEM_VOLATILE_P (x) || mode == BLKmode
       || !cselib_record_memory
-      || (FLOAT_MODE_P (mode) && flag_float_store))
+      || (FLOAT_MODE_P (mode) && GCC_OPTION (flag_float_store)))
     return 0;
 
   addr_mode = GET_MODE (XEXP (x, 0));
